////////////////////////////////////////////////////////////////////////////////
//
//  IIIIIII SSSSSS
//    II    SS                          InstallShield (R)
//    II    SSSSSS      (c) 1996-1997, InstallShield Software Corporation
//    II        SS      (c) 1990-1996, InstallShield Corporation
//  IIIIIII SSSSSS                     All rights reserved.
//
//
//    File Name: Odbcvc.h
//
//  Description: Header file for ODBC Core Template.
//
//     Comments: Contains prototypes of Installer DLL APIs, constant
//               definitions, and so on.
//
//      Updated:  18 November, 1997
//
////////////////////////////////////////////////////////////////////////////////

#ifndef ODBCVCH

#define ODBCVCH

// Prototype ODBC 3.5 template functions, which are defined in Odbcvc.rul.
prototype ISODBCCheckRequirements ( STRING );
prototype ISODBCInstallODBC35 ( STRING, STRING, STRING );
prototype ISODBCInstallODBCCore ( BYREF STRING );
prototype ISODBCHandleODBCError ( NUMBER );
prototype ISODBCGetTargetOS ( );
prototype ISODBCUpdateUninstallString ( );
prototype ISODBCSetParentWindowHandle ( );
prototype ISODBCUninstallODBC ( );

// WARNING: Do not change! These constants specify the ODBC Driver
// Manager, Administrator, and other key file names. Do not change them unless
// the actual file names themselves change, and then do so with caution.
#define ISODBC_ODBCCPLFILE          "ODBCCP32.CPL"
#define ISODBC_ODBCADMIN            "ODBCAD32.EXE"
#define ISODBC_INSTALLERDLL         "ODBCCP32.DLL"
#define ISODBC_UNINSTDLL            "_UNODBC.DLL"
#define ISODBC_UNINSTLOG            "_UNODBC.LOG"
#define ISODBC_CONTROLPANELEXE      "Control.exe"
#define ISODBC_INSTALLERDLLVER      "3.0.0.0"
#define ISODBC_VC6EDDLL             "_vc6ed.dll"
#define ISODBC_VC6EDDLL_API         "ISSQLInstallDriverManager"
#define ISODBC_VC6EDDLL_UNDOODBC    "UndoODBCCallDLLFx"

// WARNING: Do not change! The following constants must not be changed
// because these terms are hard-coded in the ODBC 3.5 template uninstaller DLL.
// They are keywords for logging ODBC items/components for uninstallation.
#define ISODBC_LOG_REMOVESECTION         "ODBC Remove"
#define ISODBC_LOG_MANAGERFLAG           "Manager"
#define ISODBC_DRIVERMANAGERFLAG         "1"

// WARNING: Do not change! These constants specify error return numbers.
#define ISODBC_ERRNO_UNKNOWNSYMBOL          -900
#define ISODBC_ERRNO_OS                     -901
#define ISODBC_ERRNO_COMPNAMEMISSING        -902
#define ISODBC_ERRNO_SECTIONREADFAILED      -903
#define ISODBC_ERRNO_GETTINGARGLIST         -904
#define ISODBC_ERRNO_NOFILEDSNS             -905
#define ISODBC_ERRNO_GETTINGARGLISTVALUE    -906
#define ISODBC_ERRNO_WINDOWHANDLE           -907
#define ISODBC_ERRNO_INSTALLERDLL           -908
#define ISODBC_ERRNO_WRITETOLOGFILE         -909
#define ISODBC_ERRNO_UPDATEUNINSTSTRING     -910
#define ISODBC_ERRNO_NOTADMINISTRATOR       -911

// WARNING: Do not change! This is the Windows-defined uninstallation string value name
// used under the application uninstallation key.
#define ISODBC_UNINSTALLSTRING      "UninstallString"

// Constants used with Installer DLL APIs. Taken from header files in the ODBC SDK.
#define _MAX_PATH   260

#define  ODBC_ADD_DSN                 1
#define  ODBC_ADD_SYS_DSN             4
#define  ODBC_INSTALL_COMPLETE        2
#define  ODBC_INSTALL_DRIVER          1
#define SQL_MAX_MESSAGE_LENGTH      512
#define SQL_SUCCESS_WITH_INFO         1
#define SQL_NO_DATA                 100
#define SQL_ERROR                    -1

// Flag indicating whether or not target OS is NT 3.51.
BOOL bTargetOSNT351ODBC;

// The following variables make values passed to ISODBCInstallODBC35 accessible globally.
// They allow the template to access the uninstallation string for the installed application.
STRING szLogPathODBC, szUninstKeyNameODBC;

#endif

