#include <windows.h>
#include "winnls.h"

typedef int (far pascal *CTLREGPROC)(void);
typedef char (far pascal *DLLEXT)(HWND,LPSTR,LPSTR,LPSTR);
typedef BOOL (far pascal *SQLINSTALLDRIVERMANAGER)(LPSTR,WORD,WORD FAR*);
typedef BOOL (far pascal *SQLINSTALLDRIVER)(LPCSTR,LPCSTR,LPSTR,WORD,WORD FAR*);
typedef BOOL (far pascal *SQLCONFIGDATASOURCE)(HWND,WORD,LPCSTR,LPCSTR);
typedef BOOL (far pascal *SQLREMOVETRANSLATOR)(LPCSTR,LPDWORD);
typedef BOOL (far pascal *SQLREMOVEDRIVER)(LPCSTR,BOOL,LPDWORD);
typedef BOOL (far pascal *SQLREMOVEDRIVERMANAGER)(LPDWORD);
typedef BOOL (far pascal *SQLREMOVEDSNFROMINI) (LPCSTR);

BOOL APIENTRY UndoODBC(const char*);
BOOL GetBaseDir(LPTSTR,char*);
void SplitName(const char*,char*,char*,char);

char szTemp[_MAX_PATH];
char szBaseDir[_MAX_PATH];

BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
   	return (1);
}

LONG APIENTRY UninstInitialize(HWND hwndDlg,HANDLE hInstance,LONG lRes)
{ LPTSTR lpStr;
  char szFile[_MAX_PATH];
  
	LPSTR sztmp;

	sztmp= new char [1024];

	//Figure where the LOG and DLL file are located
    lpStr=GetCommandLine();

	//wsprintf(sztmp,"Command Line:%s",lpStr);
	//MessageBox(GetFocus(),sztmp,"",MB_OK);
    
	if (GetBaseDir(lpStr,szBaseDir)==0)
		return(0);

	strcpy(szFile,szBaseDir);
  
	//Undo the ODBC information
	wsprintf(szFile,"%s\\_UNODBC.LOG",szBaseDir);

	//MessageBox(GetFocus(),szFile,"",MB_OK);
	UndoODBC(szFile);

	//GetModuleFileName(AfxGetInstanceHandle(),szFile,_MAX_PATH);
	//MessageBox(GetFocus(),szFile,"",MB_OK);

	return(0);
}


LONG APIENTRY UninstUnInitialize(HWND hwndDlg,HANDLE hInstance,LONG lRes)
{
	//MessageBox(GetFocus(),"End Function","",MB_OK);
	return (0);
}

// Check to make sure a directory ends in a backslash.
// If it doesn't append one.
void EndSlash(char* szDir)
{ LPTSTR lpstr,lplast;

	if (lstrlen(szDir)==0)
		return;

	lplast=szDir;
	lpstr=CharNext(szDir);
	while (*lpstr)
	{
		lplast=lpstr;
		lpstr=CharNext(lplast);
	} 

	if (IsDBCSLeadByte(*lplast))
	{
		lstrcat(szDir,"\\");
		return;
	}

	if (*lplast!='\\')
		lstrcat(szDir,"\\");

	return;
}

HMODULE LoadOdbcDll()
{ char szDll[_MAX_PATH];
  HMODULE hRet;

	GetSystemDirectory(szDll,sizeof(szDll));
	EndSlash(szDll);
	lstrcat(szDll,"ODBCCP32.DLL");
	hRet=LoadLibrary(szDll);
	if (hRet==NULL)
	{
		wsprintf(szTemp,"LoadLib of %s failed. err#=%d\r\n",szDll,hRet);
	}
	return(hRet);
}

BOOL APIENTRY UndoODBC(const char* szSrc)
{ int i=1,j=1;
  char szSection[_MAX_PATH],szValue[_MAX_PATH];
  DWORD dwSize=_MAX_PATH;
  DWORD dwCount;
  BOOL bRet;
  LPSTR sztmp;
  
  SQLREMOVETRANSLATOR SQLRemoveTranslator;
  SQLREMOVEDRIVER SQLRemoveDriver;
  SQLREMOVEDRIVERMANAGER SQLRemoveDriverManager;
  SQLREMOVEDSNFROMINI SQLRemoveDSNFromIni;
  HMODULE hModule;

	hModule = LoadOdbcDll();
	if (hModule==NULL) 
		return(FALSE);
	SQLRemoveTranslator=(SQLREMOVETRANSLATOR)GetProcAddress(hModule,"SQLRemoveTranslator");
	SQLRemoveDriver=(SQLREMOVEDRIVER)GetProcAddress(hModule,"SQLRemoveDriver");
	SQLRemoveDriverManager=(SQLREMOVEDRIVERMANAGER)GetProcAddress(hModule,"SQLRemoveDriverManager");
		SQLRemoveDSNFromIni=(SQLREMOVEDSNFROMINI)GetProcAddress(hModule,"SQLRemoveDSNFromIni");
	if ((SQLRemoveTranslator==NULL) || (SQLRemoveDriver==NULL) || (SQLRemoveDriverManager==NULL || (SQLRemoveDSNFromIni==NULL)))
	{
		wsprintf(szTemp,"GetProc failed: RemTrans=%p RemDrv=%p RemDrvMan=%d RemDSN=%d \r\n",SQLRemoveTranslator,SQLRemoveDriver,SQLRemoveDriverManager,SQLRemoveDSNFromIni);
		FreeLibrary(hModule);
		return(FALSE);
	}

	sztmp= new char [1024];
	
	i=1;
	wsprintf(szSection,"Translator%d",i);
	while(GetPrivateProfileString("ODBC Remove",szSection,"",szValue,dwSize,szSrc))
	{
		SQLRemoveTranslator(szValue,&dwCount);
		i++;
		wsprintf(szSection,"Translator%d",i);
	}

	i=1;

	wsprintf(szSection,"Driver%d",i);
	//MessageBox(GetFocus(),szSrc,"",MB_OK);
	while(GetPrivateProfileString("ODBC Remove",szSection,"",szValue,dwSize,szSrc))
	{

		bRet=SQLRemoveDriver(szValue,TRUE,&dwCount);
		
		//wsprintf(sztmp,"ret=%d drv=%s count= %ld",bRet,szValue,dwCount);
		//MessageBox(GetFocus(),sztmp,"uninst",MB_OK);
		
		i++;
		wsprintf(szSection,"Driver%d",i);
	}

		i=1;
	wsprintf(szSection,"DSN%d",i);
	while(GetPrivateProfileString("ODBC Remove",szSection,"",szValue,dwSize,szSrc))
	{
		bRet=SQLRemoveDSNFromIni(szValue);
		//wsprintf(sztmp,"ret=%d drv=%s count= %ld",bRet,szValue,dwCount);
		//MessageBox(GetFocus(),sztmp,"uninst",MB_OK);
		i++;
		wsprintf(szSection,"DSN%d",i);
	}
	
	GetPrivateProfileString("ODBC Remove","Manager","",szValue,dwSize,szSrc);
	if (atoi(szValue))
	{
		bRet=SQLRemoveDriverManager(&dwCount);
	
		//wsprintf(sztmp,"ret= %d from remove manager. count = %ld",bRet,dwCount);
		//MessageBox(GetFocus(),sztmp,"uninst",MB_OK);
	}

	return(TRUE);
}

BOOL GetBaseDir(LPTSTR lpLine,char* szBase)
{ char szLine[_MAX_PATH],szFile[_MAX_PATH];
  char* ptr;
  int len;

	lstrcpy(szLine,lpLine);
	ptr=strstr(szLine,"-c");
	if (ptr==NULL)
	{
		szBase[0]=0;
		return(0);
	}

	ptr+=2;	//skip up to filename
	if (*ptr=='"')
		++ptr;
	lstrcpy(szFile,ptr);
	len=lstrlen(szFile);
	if (szFile[len-1]=='"')
		szFile[len-1]=0;

	SplitName(szFile,szBase,szLine,'\\');
	return(TRUE);
}

void SplitName(const char* szWholeName,char* szPath,char* szFile,char chSep)
{ int i,len,j;
  LPTSTR lpstr,lplast;

	len=i=lstrlen(szWholeName);
	if (len==0)
	{
		szPath[0]=0; szFile[0]=0; return;
	}

	//First walk out to the end of the string
	lplast=(LPTSTR)szWholeName;
	lpstr=CharNext(szWholeName);
	while (*lpstr)
	{
		lplast=lpstr;
		lpstr=CharNext(lplast);
	} 

	//Now walk backward to the beginning
	while (*lplast)
	{
		if (IsDBCSLeadByte(*lplast))
		{
			lplast=CharPrev(szWholeName,lplast);
			if (lplast==szWholeName)
			{
				szPath[0]=0;
				lstrcpy(szFile,szWholeName);
				return;
			}
		}
		else if (*lplast==chSep)
		{										 
			i=lplast-szWholeName+1;
			lstrcpyn(szPath,szWholeName,i+1);
			szPath[i]=0;
			j=len-i;
			lstrcpyn(szFile,&szWholeName[i],j+1);
			szFile[j]=0;
			return;
		}
		else
		{
			lplast=CharPrev(szWholeName,lplast);
			if (lplast==szWholeName)
			{
				szPath[0]=0;
				lstrcpy(szFile,szWholeName);
				return;
			}
		}
	}

	//Didn't find it so just default the values
	szPath[0]=0;
	lstrcpy(szFile,szWholeName);
}

LONG APIENTRY RegTlbFile32(char far* szTlbFile)
{ ITypeLib *typeLib;
  HRESULT hRes;
  WORD szWTlbFile[_MAX_PATH];

    memset(szWTlbFile,0,sizeof(szWTlbFile));
	if (MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,szTlbFile,lstrlen(szTlbFile),szWTlbFile,sizeof(szWTlbFile))==0)
        return(1);
    hRes=LoadTypeLib(szWTlbFile,&typeLib);
    if (hRes!=S_OK)
        return(1);
    hRes=RegisterTypeLib(typeLib,szWTlbFile,NULL);
	if (hRes!=S_OK)
        return(1);
    return(0);
}